// CacheLFU.cpp: implementation of the CacheLFU class.
//
//////////////////////////////////////////////////////////////////////

#include "CacheLFU.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CacheLFU::CacheLFU(int iSize):Cache(iSize)
{
  strcpy(m_sName, "LFU");
  m_iAlg = LFU;
}

CacheLFU::~CacheLFU()
{

}

//////////////////////////////////////////////////////////////////////
// Protected methods
//////////////////////////////////////////////////////////////////////

// evict a page with the lowest reference count
void CacheLFU::evict()
{
  int i;

  i=1;
  while (m_vecPLsPgCache[i]->size()==0)
    i++;
  m_hash.Erase(&(m_vecPLsPgCache[i]->back()));
  m_vecPLsPgCache[i]->pop_back();
}

// this page is referenced, so increase the reference count and
//   put it into the corresponding list
void CacheLFU::updatePage(ItListHashNode cur) 
{
  ItListPage it = cur->it;
  Page page(*it);

  // delete the page from the old list
  m_hash.Erase(cur);
  m_vecPLsPgCache[page.ref]->erase(it);

  page.ref++;

  // add the page to the list with the new reference count
  if (m_vecPLsPgCache.size()<page.ref+1)
    m_vecPLsPgCache.push_back(new ListPage);
  m_vecPLsPgCache[page.ref]->push_front(page);
  m_hash.Add(m_vecPLsPgCache[page.ref]->begin());
}
