// CacheLFU.h: interface for the CacheLFU class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_CACHELFU_H_INCLUDED_)
#define _CACHELFU_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "global.h"  // Added by ClassView
#include "Cache.h"
#include "Hash.h"

// class CacheLFU inherits the class Cache and implements the LFU
// algorithm. How to evict a page is defined in evict(), and how
// to process a re-reference of a page is in updatePage()
class CacheLFU : public Cache  
{
protected:
  virtual void evict(); // evict a page
  virtual void updatePage(ItListHashNode cur);

public: // public members

public:
  CacheLFU(int iSize);
  virtual ~CacheLFU();
};

#endif // !defined(_CACHELFU_H_INCLUDED_)
