// CacheLRU.cpp: implementation of the CacheLRU class.
//
//////////////////////////////////////////////////////////////////////

#include "CacheLRU.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CacheLRU::CacheLRU(int iSize):Cache(iSize)
{
  strcpy(m_sName, "LRU");
  m_iAlg = LRU;
}

CacheLRU::~CacheLRU()
{

}

//////////////////////////////////////////////////////////////////////
// Protected methods
//////////////////////////////////////////////////////////////////////

// evict the page on the back of the list, which is the least 
//  recently referenced
void CacheLRU::evict() // evict the last page
{
  m_hash.Erase(&(m_vecPLsPgCache[1]->back()));
  m_vecPLsPgCache[1]->pop_back();
}

// because this page is referenced
// move the page to the front of the list
void CacheLRU::updatePage(ItListHashNode cur)
{
  ItListPage it = cur->it;
  Page page(*it);

  // erase it from the old location
  m_hash.Erase(cur);
  m_vecPLsPgCache[1]->erase(it);

  // add the page to the head
  m_vecPLsPgCache[1]->push_front(page);
  m_hash.Add(m_vecPLsPgCache[1]->begin());
}
