// CacheLRU.h: interface for the CacheLRU class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CACHELRU_H__D3B41482_F20C_11D3_B969_C0C652C19A15__INCLUDED_)
#define AFX_CACHELRU_H__D3B41482_F20C_11D3_B969_C0C652C19A15__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "global.h"  // Added by ClassView
#include "Cache.h"
#include "Hash.h"

// class CacheLRU inherits the class Cache and implements the LRU
// algorithm. How to evict a page is defined in evict(), and how
// to process a re-reference of a page is in updatePage()
class CacheLRU : public Cache  
{
protected:
  virtual void evict(); // evict a page
  virtual void updatePage(ItListHashNode cur);

public:
  CacheLRU(int iSize);
  virtual ~CacheLRU();
};

#endif // !defined(AFX_CACHELRU_H__D3B41482_F20C_11D3_B969_C0C652C19A15__INCLUDED_)
