// CacheRand.cpp: implementation of the CacheRand class.
//
//////////////////////////////////////////////////////////////////////

#include "CacheRand.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CacheRand::CacheRand(int iSize, int iSeed):Cache(iSize)
{
  m_randGen.srandom(iSeed);
  strcpy(m_sName, "RAN");
  m_iAlg = RAND;
}

CacheRand::~CacheRand()
{

}

//////////////////////////////////////////////////////////////////////
// Protected methods
//////////////////////////////////////////////////////////////////////

// find a random page and evict it
void CacheRand::evict() // select a random page and evict it
{
  DWORD i;
  ItListPage it;

  check();
  i = RandIdx();
  it = at(m_vecPLsPgCache[1], i);
  m_hash.Erase(&*it);
  m_vecPLsPgCache[1]->erase(it);
}

// generate a random page 
DWORD CacheRand::RandIdx()
{
  DWORD n= DWORD(m_randGen.random()*1.0/RAND_M*m_iSize) % m_iSize;
  assert(n>=0 && n<m_iSize);
  return n;
}

// get the nth page of the cache
ItListPage CacheRand::at(PListPage pListPage, int n)
{
  int i;
  ItListPage it;

  it = pListPage->begin();
  for (i=0; i<n; i++)
    it++;
  return it;
}
