// CacheRand.h: interface for the CacheRand class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CACHERAND_H__D3B41484_F20C_11D3_B969_C0C652C19A15__INCLUDED_)
#define AFX_CACHERAND_H__D3B41484_F20C_11D3_B969_C0C652C19A15__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "global.h"  // Added by ClassView
#include "Cache.h"
#include "RandGen.h"
#include "Hash.h"

// class CacheRand inherits the class Cache and implements the random
// algorithm. How to evict a page is defined in evict(). No action is
// needed for a re-reference of a page. Therefore, updataPage() is not
// defined here.
class CacheRand : public Cache  
{
protected: // protected members
  RandGen m_randGen;

protected: // protected members
  virtual void evict(); // evict a page
  DWORD RandIdx();
  ItListPage at(PListPage list, int n);

public:
  CacheRand(int iSize, int iSeed);
  virtual ~CacheRand();

};

#endif // !defined(AFX_CACHERAND_H__D3B41484_F20C_11D3_B969_C0C652C19A15__INCLUDED_)
