// Config.cpp: implementation of the Config class.
//
//////////////////////////////////////////////////////////////////////

#include "global.h"
#include "Config.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Config::Config()
{
  m_pistr = NULL;
}

Config::~Config()
{
  if (m_pistr!=NULL)
    delete m_pistr;
}

//////////////////////////////////////////////////////////////////////
// public methods
//////////////////////////////////////////////////////////////////////

// read a line, ignore comment lines and empty lines
void Config::ReadLine(char line[], int len)
{
  do
  {
    m_ifConfig.getline(line,len);
  }while (bIsBlank(line) && !m_ifConfig.eof());
}

// open the config file
void Config::open(char strConfigName[])
{
  m_ifConfig.open(strConfigName);
  if (!m_ifConfig)
    Error("Cannot open %s!\n",strConfigName);
}

// close the config file
void Config::close()
{
  m_ifConfig.close();
}

// begin to parse a new line
void Config::BeginParse()
{
  ReadLine(m_line, MaxLen);
  if (m_pistr!=NULL)
    delete m_pistr;
  m_pistr = new istrstream(m_line);
}

// if the next string in the config file equals key,
// return TRUE
BOOL Config::VerifyKey(char *key)
{
  char name[MaxLen];
  *m_pistr >> name;
  if (stricmp(name, key))
    return FALSE;
  else
    return TRUE;
}

// read the next integer from the config file
int Config::ParseInt(int &i)
{
  *m_pistr >> i;
  return i;
}

// read the next string from the config file
char *Config::ParseStr(char *str)
{
  *m_pistr >> str;
  return str;
}

//////////////////////////////////////////////////////////////////////
// protected methods
//////////////////////////////////////////////////////////////////////

// if this line is blank or comment, return TRUE
BOOL Config::bIsBlank(char line[])
{
  char *pch;
  pch = line;
  while ((*pch==' ')||(*pch=='\t'))
    pch++;
  if ((*pch==0)||(*pch=='#'))
    return TRUE;
  else
    return FALSE;
}

