// Config.h: interface for the Config class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_CONFIG_H_INCLUDED_)
#define _CONFIG_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Experiment.h"
#include "global.h"  // Added by ClassView

#define MaxLen 1023
#define EOD  -1

// class Config contains common utilities for reading config files
class Config  
{
protected:
  ifstream m_ifConfig;
  char m_line[MaxLen+1];
  istrstream *m_pistr;

protected:
  BOOL bIsBlank(char line[]);
public:
  char* ParseStr(char *str);
  int ParseInt(int &i);

  BOOL VerifyKey(char *key);
  void BeginParse();
  void open(char strConfigName[]);
  BOOL eof() { return m_ifConfig.eof(); };
  void close();
  void ReadLine(char line[], int len);
  Config();
  virtual ~Config();
};

#endif // !defined(_CONFIG_H_INCLUDED_)
