// Experiment.h: interface for the Experiment class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_EXPERIMENT_H_INCLUDED_)
#define _EXPERIMENT_H_INCLUDED_

#include "global.h"  // Added by ClassView
#include "Cache.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// class Experiment includes an experiment of the simulation
typedef class Experiment  
{
protected:
  int m_iWarmup;
  int m_iEvtNum;
public:
  PCache pClient;
  PCache pServer;
	VecInt& GetStats();
  virtual void print(ofstream &ofOutput);
  void ProcessEvent(PEvent pEvent);
  Experiment(int iCltSize, int iWarmup, 
             int iSvrSize, int iAlg, int iSeed);
  virtual ~Experiment();

}* PExperiment;

typedef vector<PExperiment> VecPExperiment;

#endif // !defined(_EXPERIMENT_H_INCLUDED_)
