// Hash.cpp: implementation of the Hash class.
//
//////////////////////////////////////////////////////////////////////

#include "global.h"
#include "Hash.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Hash::Hash(int hashSize)
{
  m_vecLsHash.resize(hashSize);
}

Hash::~Hash()
{

}

//////////////////////////////////////////////////////////////////////
// public methods
//////////////////////////////////////////////////////////////////////

// search the page in hash table, return the location
// return NULL if not found
ItListHashNode Hash::Search(PPage pPage)
{
  ListHashNode *pList;
  ItListHashNode it;
  
  pList = &(m_vecLsHash[HashValue(pPage)]);
  for ( it=pList->begin(); it!=pList->end(); it++ )
  {
    if ( *(it->it) == *pPage )
      break;
  }
  if (it == pList->end()) // not found
    it = NULL;
  return it;
}

// add the new page location into the hash table
void Hash::Add(ItListPage it) // add to hash table
{
  ListHashNode *pList;
  HashNode node(it);
  PPage pPage;

  pPage = &*it;
  pList = &(m_vecLsHash[HashValue(pPage)]);
  pList->push_back(node);
}

// erase pPage from the hash table
void Hash::Erase(PPage pPage) // erase this page from the hash table
{
  ItListHashNode it;
  it = Search(pPage);
  assert(it!=NULL); 
  Erase(it);
}

// erase the page from the hash table
void Hash::Erase(ItListHashNode it) // erase this page from the hash table
{
  ListHashNode &listHash=m_vecLsHash[HashValue(&(*(it->it)))];
  listHash.erase(it);
}

//////////////////////////////////////////////////////////////////////
// protected methods
//////////////////////////////////////////////////////////////////////

// hash function
DWORD Hash::HashValue(PPage pPage)
{
  DWORD i;
  i=(pPage->dev * pPage->inode * (pPage->block+3)) % m_vecLsHash.size();
  assert(i>=0 && i<m_vecLsHash.size());
  return i;
}

