// Hash.h: interface for the Hash class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_HASH_H_INCLUDED_)
#define _HASH_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "global.h"
#include "Page.h"

// the HashNode stores the location of the page in the cache
struct HashNode
{
  ItListPage it;
  HashNode(ItListPage the_it) { it=the_it; };
};

#define HASHSIZE 499

typedef list<HashNode> ListHashNode;
typedef ListHashNode::iterator ItListHashNode;
typedef vector<ListHashNode> VecListHashNode;

// class Hash defines a hash table. Pages in the cache can be
// found efficiently
class Hash  
{
protected:
  VecListHashNode m_vecLsHash;

protected:
  DWORD HashValue(PPage pPage);

public:
  Hash(int hashSize=HASHSIZE);
  virtual ~Hash();

  ItListHashNode Search(PPage pPage);

  void Add(ItListPage it); // add to hash table

  void Erase(PPage pPage); // erase this page from the hash table
  void Erase(ItListHashNode it); // erase this page from the hash table
};

#endif // !defined(_HASH_H_INCLUDED_)
