// RandGen.cpp: implementation of the RandGen class.
//
//////////////////////////////////////////////////////////////////////
#include "global.h"
#include "RandGen.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/*
 * constructor
 */
RandGen::RandGen()
{
  seed = 1;
}

/*
 * destructor
 */
RandGen::~RandGen() 
{
}

//////////////////////////////////////////////////////////////////////
// public methods
//////////////////////////////////////////////////////////////////////

/*
 * srandom()
 *
 * This function initialize the seed. The default value is 1
 */
void RandGen::srandom (int initial_seed)
{
  if ((initial_seed < 1) || (initial_seed > RAND_M1))
  { 
    printf("Seed %d error!\n",initial_seed);
  }
  else
  {
    seed = initial_seed;
  }
}

/*
 * random()
 *
 * This function generates a random number by this fomula
 *   Xn = Xn-1 * 7^5 % (2^31-1)
 */
int RandGen::random (void)
{
 int lo, hi, test;

 hi = seed / RAND_Q;
 lo = seed % RAND_Q;

 test = RAND_A * lo - RAND_R * hi;

 if (test > 0)
   seed = test;
 else
   seed = test + RAND_M;

 return(seed);
}
