// RandGen.h: header of the RandGen class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _RANDOM_GENERATOR_INCLUDED
#define _RANDOM_GENERATOR_INCLUDED

#define RAND_A  16807
#define RAND_M  2147483647    // max random value
#define RAND_M1 2147483646
#define RAND_MD 2147483647.0
#define RAND_Q  127773
#define RAND_R  2836

// class RandGen generates random numbers.
// the equation used is
// Xn = Xn-1 * 7^5 * (2^31-1)
class RandGen
{
public:
  RandGen();
  ~RandGen();
public:
  int random (void);
  void srandom (int initial_seed);
protected:
  int seed;
};

#endif //(_RANDOM_GENERATOR_INCLUDED)
