// Simulation.h: interface for the Simulation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_SIMULATION_H_INCLUDED_)
#define _SIMULATION_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Experiment.h"
#include "Config.h"

// class Simulation represent one simulation which includes
// many experiments with different parameters
class Simulation  
{
protected:
  char m_sTrace[256]; // trace file name
  VecPExperiment m_vecPExperiment;
  VecInt m_vecCltBuf, m_vecSrvBuf, m_vecAlg;
  int m_iWarmup;

protected:
  int  iConvAlgName(char *name);
  char* GetAlgName(int iAlg);
public:
  Simulation();
  virtual ~Simulation();
  BOOL GetNextEvent(ifstream &ifInput, PEvent pEvent);
  void ReadConfig(char *strConfigName);
  void run();
  void print(char *strOutputName);
};

#endif // !defined(_SIMULATION_H_INCLUDED_)
