#include <stdio.h>

/* node structure used to hold a single reference when read from */
/* a trace file */
struct trace_node {
  unsigned long time;     /* time of event in milli_sec since start of trace */
  int dev;
  int inode;
  int block_id;
  int flag;               /*  0 = non-shared file ref (we set this to the
                client # immediately after reading),
           -1 = shared file ref,
           -2 = unlink (vnsremove) event */
  int wr;                 /* 0 = write, 1 = read, 2 = unknown */
};

extern char filenames[MAX_CLIENTS+1][MAX_FILENAME_SIZE+1];
extern FILE *tr_files[MAX_CLIENTS+1];
extern int end_of_any_file;

extern int read_filenames();
extern void open_trace_file();
extern struct trace_node read_trace();
